// From https://stackoverflow.com/questions/34187171/fast-integer-square-root-approximation
#include <stdlib.h>
#include <stdio.h>

unsigned usqrt4(unsigned val) {
    unsigned a, b;

    if (val < 2) return val; /* avoid div/0 */

    a = 1255;       /* starting point is relatively unimportant */

    b = val / a; a = (a+b) /2;
    b = val / a; a = (a+b) /2;
    b = val / a; a = (a+b) /2;
    b = val / a; a = (a+b) /2;
    b = val / a; a = (a+b) /2;
    b = val / a; a = (a+b) /2;
    b = val / a; a = (a+b) /2;
    b = val / a; a = (a+b) /2;
    b = val / a; a = (a+b) /2;
    b = val / a; a = (a+b) /2;

    return a;
}

int main (int argc, char* argv[]) {
    if(argc > 1)
        printf("%d\n", usqrt4(atoi(argv[1])));
    return 0;
}
